---
title: FileReader.result
slug: Web/API/FileReader/result
tags:
  - API
  - File API
  - FileReader
  - Files
  - Property
  - Reference
  - result
---
<div>{{APIRef("File API")}}</div>

<p>The {{domxref("FileReader")}} <code><strong>result</strong></code> property returns the file's contents. This property is only valid after the read operation is complete, and the format of the data depends on which of the methods was used to initiate the read operation.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>file</var> = <var>instanceOfFileReader</var>.result
</pre>

<h3 id="Value">Value</h3>

<p>An appropiate string or {{jsxref("ArrayBuffer")}} based on which of the reading methods was used to initiate the read operation. The value is <code>null</code> if the reading is not yet complete or was unsuccessful.</p>

<p>The result types are described below.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Method</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{domxref("FileReader/readAsArrayBuffer", "readAsArrayBuffer()")}}</td>
   <td>The <code>result</code> is a JavaScript {{jsxref("Global_Objects/ArrayBuffer", "ArrayBuffer")}} containing binary data.</td>
  </tr>
  <tr>
   <td>{{domxref("FileReader/readAsBinaryString", "readAsBinaryString()")}}</td>
   <td>The <code>result</code> contains the raw binary data from the file in a string.</td>
  </tr>
  <tr>
   <td>{{domxref("FileReader/readAsDataURL", "readAsDataURL()")}}</td>
   <td>The <code>result</code> is a string with a <code>data:</code> URL representing the file's data.</td>
  </tr>
  <tr>
   <td>{{domxref("FileReader/readAsText", "readAsText()")}}</td>
   <td>The <code>result</code> is text in a string.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>This example presents a function, <code>read()</code>, which reads a file from a <a href="/en-US/docs/Web/HTML/Element/input/file">file input</a>. It works by creating a {{domxref("FileReader")}} object and creating a listener for {{domxref("FileReader/load_event", "load")}} events such that when then file is read, the <code>result</code> is obtained and passed to the callback function provided to <code>read()</code>.</p>

<p>The content is handled as raw text data.</p>

<pre class="brush: js">var fileInput = document.querySelector('input[type="file"]');

function read(callback) {
  var file = fileInput.files.item(0);
  var reader = new FileReader();

  reader.onload = function() {
    callback(reader.result);
  }

  reader.readAsText(file);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("File API", "#dom-filereader-result", "result")}}</td>
   <td>{{Spec2("File API")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileReader.result")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("FileReader")}}</li>
</ul>
